## cduce 0.4.1

=== Makefile ===
--- 
+++ 
@@ -97,7 +97,7 @@
 	@echo "Install binaries"
 	$(HIDE)mkdir -p $(BINDIR)
 	$(HIDE)$(INSTALL) -m755 $(INSTALL_BINARIES) $(BINDIR)/
-	
+
 
 install_lib:
 	@echo "Build META"
@@ -146,6 +146,7 @@
  schema/schema_builtin.cmo schema/schema_validator.cmo \
  \
  types/patterns.cmo \
+ compile/print_auto.cmo \
  \
  compile/lambda.cmo \
  runtime/run_dispatch.cmo runtime/explain.cmo runtime/eval.cmo \
@@ -159,7 +160,6 @@
  schema/schema_parser.cmo schema/schema_converter.cmo \
  runtime/load_xml.cmo runtime/print_xml.cmo compile/operators.cmo types/builtin.cmo \
  driver/librarian.cmo types/sample.cmo \
- compile/print_auto.cmo \
  driver/cduce.cmo \
  \
  runtime/system.cmo query/query_aggregates.cmo
@@ -240,7 +240,7 @@
 
 cduce_lib.$(EXTENSION_LIB): $(OBJECTS:.cmo=.$(EXTENSION))
 	@echo "Pack cduce_lib.$(EXTENSION)"
-	$(HIDE)$(COMPILE) -o cduce_lib.$(EXTENSION) -pack $^
+	$(HIDE)$(COMPILE) -o cduce_lib.$(EXTENSION) $(INCLUDES) -pack $^
 	@echo "Build $@"
 	$(HIDE)$(COMPILE) -a -o $@ cduce_lib.$(EXTENSION)
 
@@ -257,7 +257,7 @@
 	for i in $(CLEAN_DIRS); do \
 	(cd $$i; rm -f *.cmi *.cmo *.cma *.cmx *.o *.a *.cmxa *~); \
 	done
-	(cd ocamliface; make clean)
+	(cd ocamliface; $(MAKE) clean)
 	rm -f `find . -name "*~"`
 	rm -f *.cmi *.cmo *.cma *.cmx *.a *.cmxa *.o *~ META
 	rm -f cduce$(EXE) ocamlprof.dump
