=== ocamliface/Makefile ===
--- 
+++ 
@@ -6,7 +6,6 @@
 all: caml_cduce.cmo caml_cduce.cmx
 
 STDLIB=$(shell ocamlc -where)
-CMI_MAGIC=$(shell grep cmi_magic ocaml-3.08.4/utils/config.mlp)
 
 
 ifeq ($(FORPACK),true)
@@ -27,13 +26,13 @@
 
 caml_cduce.cmo: ocaml_files
 	@echo "Build $@"
-	(cd ocaml_files; ocamlc $(FORPACKOPT1) $@ -c $(COMPILE_FILES);\
+	(cd ocaml_files; ocamlc $(FORPACKOPT1) -c $(COMPILE_FILES);\
 	ocamlc $(FORPACKOPT2) -pack -o $@ $(OBJECTS); \
 	cp caml_cduce.cmo caml_cduce.cmi ..)
 
 caml_cduce.cmx: ocaml_files
 	@echo "Build $@"
-	(cd ocaml_files; ocamlopt $(FORPACKOPT1) $@ -c $(COMPILE_FILES);\
+	(cd ocaml_files; ocamlopt $(FORPACKOPT1) -c $(COMPILE_FILES);\
 	ocamlopt $(FORPACKOPT2) -pack -o $@ $(XOBJECTS); \
 	cp caml_cduce.cmx caml_cduce.o caml_cduce.cmi ..)
