## cduce 0.5.0

=== Makefile ===
--- 
+++ 
@@ -66,14 +66,14 @@
   EXTENSION_LIB = cmxa
   CAML=ocamlopt
   COMPILE = $(CAMLOPT)
-  LINK = $(CAMLOPT) -linkpkg gramlib.cmxa camlp4.cmxa pr_o.cmx
+  LINK = $(CAMLOPT) -linkpkg camlp4lib.cmxa
   SYNTAX += -symbol ocaml_compiler=\"native\"
 else
   EXTENSION = cmo
   EXTENSION_LIB = cma
   COMPILE = $(CAMLC)
   CAML=ocamlc
-  LINK = $(CAMLC) -custom -linkpkg gramlib.cma camlp4.cma pr_o.cmo
+  LINK = $(CAMLC) -custom -linkpkg camlp4lib.cma
   SYNTAX += -symbol ocaml_compiler=\"bytecode\"
 endif
 
@@ -131,7 +131,7 @@
 # Objects to build
 
 OBJECTS = \
- driver/config.cmo misc/stats.cmo misc/custom.cmo misc/encodings.cmo \
+ driver/cduce_config.cmo misc/stats.cmo misc/custom.cmo misc/encodings.cmo \
  misc/upool.cmo misc/pretty.cmo misc/ns.cmo misc/imap.cmo misc/html.cmo \
  \
  types/compunit.cmo types/sortedList.cmo misc/bool.cmo types/ident.cmo \
@@ -151,7 +151,7 @@
  compile/lambda.cmo \
  runtime/run_dispatch.cmo runtime/explain.cmo runtime/eval.cmo \
  \
- parser/location.cmo  parser/url.cmo \
+ parser/cduce_loc.cmo  parser/url.cmo \
  parser/ulexer.cmo parser/ast.cmo parser/parser.cmo \
  \
  typing/typed.cmo typing/typepat.cmo types/externals.cmo typing/typer.cmo \
@@ -281,7 +281,7 @@
 
 misc/q_symbol.cmo: misc/q_symbol.ml
 	@echo "Build $@"		  
-	$(HIDE)$(CAMLC) -c -pp 'camlp4o pa_extend.cmo q_MLast.cmo' $<
+	$(HIDE)$(CAMLC) -c -pp camlp4orf $<
 
 .ml.cmo:
 	@echo "Build $@"
