=== ocamliface/Makefile ===
--- 
+++ 
@@ -19,14 +19,15 @@
 ocaml_files:
 	mkdir ocaml_files
 	$(HIDE)cp $(patsubst %,$(OCAML_SRC)/%, $(COPY_FILES)) ocaml_files/
-	cp location.ml ocaml_files
-	mv ocaml_files/asttypes.mli ocaml_files/asttypes.ml
+	cp location.ml ocaml_files/location.ml
+	cp ocaml_files/asttypes.mli ocaml_files/asttypes.ml
 	sed s=STDLIB=$(STDLIB)= config.ml > ocaml_files/config.ml
 	grep cmi_magic $(OCAML_SRC)/utils/config.mlp >> ocaml_files/config.ml
 
 caml_cduce.cmo: ocaml_files
 	@echo "Build $@"
-	(cd ocaml_files; ocamlc $(FORPACKOPT1) -c $(COMPILE_FILES);\
+	(cd ocaml_files; \
+	ocamlc $(FORPACKOPT1) -c $(COMPILE_FILES);\
 	ocamlc $(FORPACKOPT2) -pack -o $@ $(OBJECTS); \
 	cp caml_cduce.cmo caml_cduce.cmi ..)
 
@@ -42,7 +43,9 @@
 COPY_FILES=\
   utils/misc.ml utils/tbl.ml \
   utils/consistbl.ml utils/warnings.ml utils/terminfo.ml utils/clflags.ml \
-  parsing/asttypes.mli parsing/longident.ml \
+  parsing/asttypes.mli parsing/location.mli \
+  parsing/longident.ml \
+  typing/outcometree.mli \
   typing/ident.ml typing/path.ml \
   typing/primitive.ml typing/types.ml \
   typing/btype.ml typing/oprint.ml \
@@ -51,9 +54,10 @@
   typing/ctype.ml typing/ctype.mli typing/printtyp.ml
 
 COMPILE_FILES=\
+  asttypes.mli outcometree.mli asttypes.ml \
   config.ml misc.ml tbl.ml \
   clflags.ml consistbl.ml warnings.ml terminfo.ml \
-  location.ml asttypes.ml longident.ml \
+  location.mli location.ml longident.ml \
   ident.ml path.ml \
   primitive.ml types.ml \
   btype.ml oprint.ml \
