## cduce 0.5.3

=== Makefile ===
--- 
+++ 
@@ -1,3 +1,5 @@
+default: cduce
+
 include Makefile.conf
 include VERSION
 
@@ -14,7 +16,7 @@
 all: cduce_lib.cmxa
 endif
 
-PACKAGES = ulex camlp4 pcre num netstring cgi
+PACKAGES = camlp4 ulex pcre num netstring 
 
 # Call make with VERBOSE=true to get a trace of commands
 
@@ -57,6 +59,7 @@
 ifeq ($(INTERFACE), true)
 	OPT += -passopt -i
 endif
+
 OCAMLFIND = ocamlfind
 CAMLC = $(OCAMLFIND) $(CAMLC_P) $(OPT) -package "$(PACKAGES)"
 CAMLOPT = $(OCAMLFIND) $(CAMLOPT_P) $(OPT) -package "$(PACKAGES)"
@@ -66,7 +69,14 @@
   EXTENSION_LIB = cmxa
   CAML=ocamlopt
   COMPILE = $(CAMLOPT)
-  LINK = $(CAMLOPT) -linkpkg camlp4lib.cmxa
+  LINK = $(CAMLOPT) -linkpkg
+  ifeq ($(NATDYNLINK), true)
+    LINK += dynlink.cmxa
+  endif
+  ifeq ($(ADDICON), true)
+    LINK += cduceres.o
+  endif
+  LINK += camlp4lib.cmxa
   SYNTAX += -symbol ocaml_compiler=\"native\"
 else
   EXTENSION = cmo
@@ -125,7 +135,7 @@
 
 # Source directories 
 
-DIRS = misc parser schema typing types compile runtime driver query ocamliface
+DIRS = misc parser schema typing types compile runtime driver query ocamliface win32
 CLEAN_DIRS = $(DIRS) tools tests
 
 # Objects to build
@@ -196,16 +206,24 @@
 endif
 
 ifeq ($(PXP),true)
-  OBJECTS += runtime/cduce_pxp.cmo
-  PACKAGES += $(PXP_PACK)
-  ALL_TARGET += dtd2cduce
-  INSTALL_BINARIES += dtd2cduce
-endif
+    OBJECTS += runtime/cduce_pxp.cmo
+    PACKAGES += $(PXP_PACK)
+    ifeq ($(CGI),true)
+      OBJECTS += runtime/cduce_pxp.cmo
+      PACKAGES += netcgi1
+      ALL_TARGET += dtd2cduce
+      INSTALL_BINARIES += dtd2cduce
+  endif
+endif
+
 ifeq ($(EXPAT), true)
   OBJECTS += runtime/cduce_expat.cmo
   PACKAGES += expat
 endif
 
+ifeq ($(ADDICON), true)
+  OBJECTS += cduceres.o
+endif
 
 all: $(ALL_TARGET)
 
@@ -224,7 +242,8 @@
 
 DEPEND = $(ALL_OBJECTS:.cmo=.ml) $(ALL_OBJECTS:.cmo=.mli) $(ALL_INTERFACES)
 
-INCLUDES = $(DIRS:%=-I %) -I +camlp4
+INCLUDES = $(DIRS:%=-I %)
+# -I +camlp4
 
 cduce: $(CDUCE:.cmo=.$(EXTENSION))
 	@echo "Build $@"
@@ -246,7 +265,7 @@
 
 dtd2cduce: tools/dtd2cduce.ml
 	@echo "Build $@"
-	$(HIDE)$(OCAMLFIND) $(CAML) -o $@ -package "$(PXP_PACK) cgi" -linkpkg $^
+	$(HIDE)$(OCAMLFIND) $(CAML) -o $@ -package "$(PXP_PACK) netcgi1" -linkpkg $^
 
 .PHONY: compute_depend
 compute_depend: $(DEPEND_OCAMLDEP)
@@ -297,13 +316,16 @@
 
 include depend
 
+cduceres.o: win32/cduce.rc win32/cduce_logo-bw.ico
+	(cd win32; windres -i cduce.rc -o cduceres.o; mv cduceres.o ..)
+
 # Documentation
 
 doc: cduce web/site.cdo
 	mkdir -p web/doc
 	(cd web; ../cduce --run site.cdo --arg doc.xml -o doc)
 
-web/site.cdo: cduce web/xhtml.cdo web/site.cd
+web/site.cdo: cduce web/xhtml.cdo web/site.cd web/siteTypes.cd
 	./cduce -I web/ --compile web/site.cd
 
 web/xhtml.cdo: cduce web/xhtml.cd
