=== debian/changelog ===
cduce (0.5.3-3) unstable; urgency=low

  [ Stéphane Glondu ]
  * Switch to dh-ocaml 0.9 (Closes: #599297)
  * Switch source package format to 3.0 (quilt)
  * debian/rules: switch to dh with overrides
  * debian/control:
    - add myself to Uploaders, and remove Stefano
    - bump Standards-Version to 3.9.1 (no changes)

  [ Mehdi Dogguy ]
  * Team upload.
  * Upload to unstable.
  * Don't compile to native code on native architectures without natdynlink.
    It won't work because cduce needs Camlp4lib, which need Dynlink.
  * Don't install copies of manpages (Closes: #577214).

 -- Mehdi Dogguy <mehdi@debian.org>  Fri, 22 Apr 2011 13:08:30 +0200

cduce (0.5.3-2) unstable; urgency=low

  [ Stephane Glondu ]
  * Add build-dependency to quilt and README.source
  * Add a patch to explicitly link dynlink.cma in the bytecode version
    (fixes FTBFS on bytecode-only architectures)
  * Add debian/clean

  [ Stefano Zacchiroli ]
  * debian/control: add version requirement on libcurl-ocaml-dev build-dep
    to entail dep-wait

 -- Stefano Zacchiroli <zack@debian.org>  Wed, 25 Mar 2009 10:21:48 +0100

cduce (0.5.3-1) unstable; urgency=low

  [ Stefano Zacchiroli ]
  * add Homepage field to debian/control

  [ Ralf Treinen ]
  * debian/watch: use info from download.html web pages (closes: Bug#450060)

  [ Pietro Abate ]
  * switch packaging to git
  * new upstream release (0.5.3)
  * recompile with ocaml 3.11
  * bump Standards-Version to 3.8.1 (no changes)
  * add a build-dependency on dh-ocaml
  * use @OCamlStdlibDir@ in cduce.dirs.in
  * remove dpatch dependency
  * bump debhelper compatibility to 7
  * set Maintainer to d-o-m
  * add myself to Uploaders

 -- Pietro Abate <pietro.abate@pps.jussieu.fr>  Mon, 23 Mar 2009 17:47:53 +0100

cduce (0.5.0-2) unstable; urgency=low

  * uploading to unstable

 -- Stefano Zacchiroli <zack@debian.org>  Sun, 09 Sep 2007 10:13:57 +0200

cduce (0.5.0-1) experimental; urgency=low

  [ Stefano Zacchiroli ]
  * new upstream release (0.5.0)
  * rebuild against OCaml 3.10 (a requirement for this new upstream)
  * bump debheper compatibility level and dependencies to 5
  * debian/rules
    - use as a replacement for .in files the same stem ("@OCamlABI@") used by
      the CDBS class, to ease future migration to that
    - build with ocamlc on ia64 to workaround a FTBFS on that arch, thanks to
      Julien Cristau for the patch (closes: #419892)
  * debian/control
    - add build-dep on camlp4(-extra), which is now in a separate package
    - removed old versioned deps, no longer needed post-etch

  [ Thomas Petazzoni ]
  * Fix typos in package description (closes: #399797)

 -- Stefano Zacchiroli <zack@debian.org>  Sun, 12 Aug 2007 19:34:00 +0200

cduce (0.4.1-1) unstable; urgency=low

  * New upstream release 0.4.1
  * Do not put the Debian package version in the Build-Depends and Depends

 -- Thomas Petazzoni <thomas.petazzoni@enix.org>  Tue,  3 Oct 2006 19:21:24 +0200

cduce (0.4.0-4.1) unstable; urgency=low

  * NMU.

  [ Julien Cristau ]
  * Bump build-deps on libpcre-ocaml-dev and libocamlnet-dev for new upstream
    release of pcre-ocaml.

  [ Samuel Mimram ]
  * Remove control.in as per new ocaml policy.

 -- Samuel Mimram <smimram@debian.org>  Thu, 14 Sep 2006 20:16:49 +0000

cduce (0.4.0-4) unstable; urgency=low

  * Bump up Standards-Version to 3.7.2.
  * Update to ocaml 3.09.2.

 -- Thomas Petazzoni <thomas.petazzoni@enix.org>  Sun, 21 May 2006 12:23:19 +0200

cduce (0.4.0-3) unstable; urgency=low

  * Update to ocaml 3.09.1.

 -- Thomas Petazzoni <thomas.petazzoni@enix.org>  Sat, 13 May 2006 11:45:29 +0200

cduce (0.4.0-2) unstable; urgency=low

  * Update to ocaml 3.09.
  * No longer hardcoding OCaml's ABI in debian/* files.

 -- Thomas Petazzoni <thomas.petazzoni@enix.org>  Sun,  4 Dec 2005 23:03:09 +0100

cduce (0.4.0-1) unstable; urgency=low

  * New upstream version 0.4.0. Changes since 0.3.92:
   - Adapted to OCaml 3.09.
   - To build the OCaml/CDuce interface, OCaml sources are now needed.

  * Drop dependency against ocaml-compiler-libs, add dependency against
    ocaml-source, and build the OCaml/CDuce interface using the compiler
    sources.

 -- Thomas Petazzoni <thomas.petazzoni@enix.org>  Mon, 31 Oct 2005 01:20:25 +0100

cduce (0.3.92-1) unstable; urgency=low

  * New upstream version 0.3.92. Changes since 0.3.91:
   - Tools:
    * Build and install dtd2cduce when PXP is available.
    * Display of location for errors and warnings compatible with OCaml.
   - Language:
    * Better error messages for xtransform.
   - Bug fix:
    * Forgot PLIST.godi in the package.
  * debian/control
    - versioned dependencies on curl and pcre

 -- Thomas Petazzoni <thomas.petazzoni@enix.org>  Thu, 20 Oct 2005 19:31:08 +0200

cduce (0.3.91-3) unstable; urgency=low

  * Recompile against new version of Curl.

 -- Thomas Petazzoni <thomas.petazzoni@enix.org>  Wed, 14 Sep 2005 22:44:13 +0200

cduce (0.3.91-2) unstable; urgency=low

  Changes by Thomas Petazzoni
  * Recompile with new version of netstring.

  Changes by Stefano Zacchiroli:
  * debian/control
    - bumped standards-version
    - versioned dependencies on ocamlnet

 -- Thomas Petazzoni <thomas.petazzoni@enix.org>  Sun, 31 Jul 2005 12:04:59 +0200

cduce (0.3.91-1) unstable; urgency=low

  * New upstream version of cduce. Changes:
   - Language:
    * Added split_atom, make_atom. Removed atom_of.
    * Added char_of_int built_in function.
    * Now int_of also accepts octal binary and hexadecimals.
    * The field access also works for XML element attributes.
    * More catchable exceptions (for load_xml, load_file, etc).
    * namespaces, schemas, "using" identifiers are now exported.
    * "open" statement.

   - Implementation:
    * More efficient implementation of records at runtime.
    * Clean-up of the internal representation.
    * The XML Schemas are now parsed only at compile time.
    * The automata for pattern matching are now produced at compile time.

   - Tools:

