=== debian/control ===
Source: cduce
Section: interpreters
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Stéphane Glondu <glondu@debian.org>,
 Pietro Abate <pietro.abate@pps.jussieu.fr>
Build-Depends:
 debhelper (>= 7.2.11~),
 dh-ocaml (>= 0.9~),
 ocaml-nox (>= 3.11.1-3~),
 camlp4-extra,
 ocaml-source (>= 3.11.0),
 libpcre-ocaml-dev (>= 6.0.1-2~),
 libocamlnet-ocaml-dev (>= 2.2.9-7~),
 libexpat-ocaml-dev (>= 0.9.1+debian1-6~),
 libcurl-ocaml-dev (>= 0.5.1-2~),
 ocaml-ulex (>= 1.1-2~),
 chrpath,
 bzip2
Standards-Version: 3.9.1
Homepage: http://www.cduce.org
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/cduce.git
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/cduce.git

Package: cduce
Architecture: any
Depends: ${ocaml:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${ocaml:Provides}
Description: programming language adapted to the manipulation of XML data
 CDuce is a modern programming language adapted to the manipulation of
 XML documents.
 .
 Some of CDuce's peculiar features:
  - XML objects can be manipulated as first-class citizen values:
    elements, sequences, tags, characters and strings, attribute sets;
    sequences of XML elements can be specified by regular expressions,
    which also apply to characters strings;
  - functions themselves are first-class values, they can be
    manipulated, stored in data structure, returned by a function,...;
  - a powerful pattern matching operation can perform complex
    extractions from sequences of XML elements;
  - a rich type algebra, with recursive types and arbitrary boolean
    combinations (union, intersection, complement) allows precise
    definitions of data structures and XML types; general purpose
    types and types constructors are taken seriously (products,
    extensible records, arbitrary precision integers with interval
    constraints, Unicode characters);
  - polymorphism through a natural notion of subtyping, and overloaded
    functions with dynamic dispatch; - an highly-effective type-driven
    compilation schema.
 .
 CDuce is fast, functional, type-safe, and conforms to basic
 standards: Unicode, XML, DTD, Namespaces are fully supported, partial
 support of XML Schema validation is in alpha testing (and
 undocumented) while queries are being implemented.
