## cduce 0.5.4

=== ocamliface/Makefile ===
--- 
+++ 
@@ -41,6 +41,7 @@
 	rm -Rf ocaml_files *~ *.cm*
 
 COPY_FILES=\
+  typing/annot.mli \
   utils/misc.ml utils/tbl.ml \
   utils/consistbl.ml utils/warnings.ml utils/terminfo.ml utils/clflags.ml \
   parsing/asttypes.mli parsing/location.mli \
@@ -57,7 +58,7 @@
   asttypes.mli outcometree.mli asttypes.ml \
   config.ml misc.ml tbl.ml \
   clflags.ml consistbl.ml warnings.ml terminfo.ml \
-  location.mli location.ml longident.ml \
+  location.mli location.ml annot.mli longident.ml \
   ident.ml path.ml \
   primitive.ml types.ml \
   btype.ml oprint.ml \
