=== debian/changelog ===
cduce (0.5.4-1build3) precise; urgency=low

  * Rebuild for OCaml 3.12.1.

 -- Colin Watson <cjwatson@ubuntu.com>  Sat, 19 Nov 2011 16:57:13 +0000

cduce (0.5.4-1build2) precise; urgency=low

  * Rebuild for new OCaml library ABIs.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 11 Nov 2011 21:03:00 +0000

cduce (0.5.4-1build1) precise; urgency=low

  * Rebuild for new libocamlnet-ocaml-dev ABI.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 24 Oct 2011 11:47:30 +0100

cduce (0.5.4-1) unstable; urgency=low

  * Team upload
  * New upstream release
  * Bump Standards-Version to 3.9.2

 -- Stéphane Glondu <glondu@debian.org>  Mon, 11 Jul 2011 21:22:36 +0200
