## cduce 0.5.5

=== Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 all: cduce_lib.cmxa
 endif
 
-PACKAGES = camlp4 ulex pcre num netstring 
+PACKAGES = dynlink camlp4 ulex pcre num netstring 
 
 # Call make with VERBOSE=true to get a trace of commands
