=== debian/changelog ===
cduce (0.5.5-1build2) trusty; urgency=medium

  * Rebuild for ocaml-4.01.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Dec 2013 22:01:45 +0000

cduce (0.5.5-1build1) saucy; urgency=low

  * Rebuild for new OCaml ABIs.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 09 May 2013 18:05:49 +0100

cduce (0.5.5-1) unstable; urgency=low

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sat, 03 Mar 2012 22:51:57 +0100
