=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
  ocaml-ulex (>= 1.1-2~),
  chrpath,
  bzip2
-Standards-Version: 3.9.1
+Standards-Version: 3.9.2
 Homepage: http://www.cduce.org
 Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/cduce.git
 Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/cduce.git
